/*
 * $Id: rb_window.c 50 2004-08-01 10:18:39Z tilman $
 *
 * Copyright (C) 2004 Tilman Sauerbeck (tilman at code-monkey de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <ruby.h>

#include <Ecore.h>
#include <Ecore_X.h>

#define __RB_WINDOW_C
#include "../ecore/rb_ecore.h"
#include "rb_ecore_x.h"
#include "rb_window.h"

VALUE cWindow;

static void c_mark (RbWindow *w)
{
	if (!NIL_P (w->parent))
		rb_gc_mark (w->parent);
}

VALUE TO_ECORE_X_WINDOW (VALUE parent, Ecore_X_Window w)
{
	VALUE self;
	RbWindow *window = NULL;

	if (!w)
		return Qnil;

	self = Data_Make_Struct (cWindow, RbWindow, c_mark, free, window);

	window->real = w;
	window->parent = parent;

	rb_obj_call_init (self, 0, NULL);

	return self;
}

void Init_Window (void)
{
	cWindow = rb_define_class_under (mX, "Window", rb_cObject);

	/* not publically instantiable yet */
	rb_define_private_method (rb_singleton_class (cWindow),
	                          "new", NULL, 0);
}
